<?php
	include "config.inc.php";
	include "lib/Yahoo.inc";
	
	class RatingUtil
	{
		public $hasSession;
		public $sessionStore;
		public $session;
		
		private $_consumer;
		private $_appid;
		
		public function RatingUtil()
		{
			$this->sessionStore = new CookieSessionStore();
			
			$this->_appid = APPID;
			
			$consumer = new stdclass();
			$consumer->key = CONSUMER_KEY;
			$consumer->secret = CONSUMER_SECRET;
			
			$this->_consumer = $consumer;
			
			$this->createSession();
		}
		
		private function createSession()
		{
			$this->hasSession = YahooSession::hasSession($this->_consumer->key,
									$this->_consumer->secret,
									$this->_appid, $this->sessionStore);
			
			if($this->hasSession) {
				$this->session = YahooSession::requireSession($this->_consumer->key, 
									$this->_consumer->secret,
									$this->_appid, NULL, $this->sessionStore);
			}
		}
		
		public function insertUpdate($title, $link, $description="")
		{
			$user = $this->session->getSessionedUser();
			$guid = $user->guid;
			
			// generate a unique id by hashing each update field.
			$suid = md5($title.$link.$description.$rating.$guid.time());
			
			// pass the update fields to the sdk to send the request
			$update = $user->insertUpdate($suid, $title, $link, $description);
			
			$rsp = array();
			$rsp['update'] = $update;
			$rsp['suid'] = $suid;
			
			return $rsp;
		}
		
		public function createAuthorizationUrl($callbackUrl)
		{
			$token = $this->createRequestToken($callbackUrl);
			return YahooAuthorization::createAuthorizationUrl($token);
		}
		
		private function createRequestToken($callbackUrl)
		{
			$token = YahooAuthorization::getRequestToken($this->_consumer->key, 
						$this->_consumer->secret, $callbackUrl);
						
			$stored = $this->sessionStore->storeRequestToken($token);
			
			return $token;
		}
	}
?>