<?php
	require_once("RatingUtil.inc.php");
	
	header("Content-Type: application/json; charset=utf-8");
	
	if( isPost() && hasRequiredParams() )
	{
		// grab rating variables
		$id = $_POST['id'];
		$show_name = $_POST['show_name'];
		$rating = $_POST['rating'];
		
		// create a new RatingUtil object
		// this contains our oauth consumer, session and methods
		// for creating updates
		$ratingUtil = new RatingUtil();
		
		if( !$ratingUtil->hasSession )
		{
			// build a callback URL for OAuth to return the user to after authorization
			$callback = sprintf("http://%s/oauth_callback.php?%s", APP_PATH,
					http_build_query(array("id"=>$id, "show_name"=>$show_name,"rating"=>$rating)) );
			
			// using our consumer token and callback, a request token is created
			// and then used to create an authorization url
			$authUrl = $ratingUtil->createAuthorizationUrl($callback);
			
			// create the response data and echo the data
			$rsp = array();
			$rsp["callbackUrl"] = $callback;
			$rsp["authorizationUrl"] = $authUrl;
			$rsp["hasSession"] = $ratingUtil->hasSession;
			
			echo json_encode($rsp);
		}
		else
		{
			$title = sprintf("gave %s %s stars on Mike's TV blog.", $show_name, $rating);
			$link = sprintf("http://%s",APP_PATH);
		
			$update_rsp = $ratingUtil->insertUpdate($title, $link);
			$update = $update_rsp['update'];
			$suid = $update_rsp['suid'];
		
			$rsp = array();
			$rsp["suid"] = $suid;
			$rsp["update"] = $update;
			$rsp["hasSession"] = $ratingUtil->hasSession;
			
			echo json_encode($rsp);
		}
	}
	
	function isPost(){
		return ($_SERVER['REQUEST_METHOD']=="POST");
	}
	
	function hasRequiredParams(){
		return (isset($_POST['id']) && isset($_POST['show_name']) && isset($_POST['rating']));
	}
?>